package labss.lang.il.model.impl;

import java.io.*;

/**
 * @author Riccardo Solmi
 */

public class BooleanLiteral extends AbstractLiteral {
	// Singleton
	public static final BooleanLiteral TRUE = new BooleanLiteral(true);
	public static final BooleanLiteral FALSE = new BooleanLiteral(false);
	public static final BooleanLiteral instance(boolean value) {
		return value ? TRUE: FALSE;
	}

	private boolean val;
	private BooleanLiteral(boolean val) {
		this.val = val;
	}
	
	public void prettyPrint(PrintStream out) {
		out.print(val);
	}
	
	public boolean booleanValue() {
		return val;
	}
	
	public String toString() {
		return String.valueOf(val);
	}
}