package labss.lang.il.model.impl;

import java.io.PrintStream;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Literal;
import labss.lang.il.model.Statement;

public class MonoImpl implements Expression, Statement {
	private static final String DIV = " / ";
	public static final String ADD = " + ";
	public static final String WHILE = "WHIE";
	
	Expression exp1;
	Expression exp2;
	String op;
	int op_ord;
	
	private Statement stm;

	public MonoImpl(Expression exp, Statement stm, String op) {
		this.exp1 = exp;
		this.stm = stm;
	}

	public MonoImpl(Expression exp1, Expression exp2, String op) {
		this.exp1 = exp1;
		this.exp2 = exp2;
		this.op = op;
	}
	
	public final Literal evaluate() {
//		switch (op_ord) {
//		case ADD_ORD:...
//		}
		if (op.equals(ADD))
			return evaluateAdd();
		else if (op.equals(DIV))
			return evaluateDiv();
		return null;//TODO
	}
	protected Literal evaluateAdd() {
		return new IntegerLiteral(exp1.evaluate().intValue()
				+ exp2.evaluate().intValue());
	}
	public Literal evaluateDiv() {
		return new IntegerLiteral(exp1.evaluate().intValue()
				/ exp2.evaluate().intValue());
	}
	
	public void prettyPrint(PrintStream out) {
		exp1.prettyPrint(out);
		out.print(op);
		exp2.prettyPrint(out);

	}

	public void execute() {
		if (op.equals(WHILE))
			executeWhile();
	}
	public void executeWhile() {
		while (exp1.evaluate().booleanValue())
			stm.execute();
	}
}
