package labss.lang.il.model.impl;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class StaticLanguageFactory {
	
  public static Statement createWhile(Expression exp, Statement stm) {
    return new WhileStatement(exp, stm);
  }

  public static Statement createIf(Expression exp, Statement thenStm) {
    return new IfStatement(exp, thenStm);
  }

  public static Statement createIf(Expression exp, Statement thenStm, Statement elseStm) {
    return new IfElseStatement(exp, thenStm, elseStm);
  }

  public static Statement createAssignment(Expression var, Expression exp) {
    return new AssignmentStatement(var, exp);
  }

  public static Statement createBlock(Statement[] stm) {
    return new BlockStatement(stm);
  }

  public static Literal createLiteral(boolean val) {
    return BooleanLiteral.instance(val);
  }

  public static Literal createLiteral(int val) {
    return new IntegerLiteral(val);
  }
  
  public static Expression createVariable(String name) {
    return new Variable(name);
  }

  public static Expression createAddition(Expression exp1, Expression exp2) {
	  return new AdditionExpression(exp1, exp2);
  }

  public static Expression createSubtraction(Expression exp1, Expression exp2) {
    return new SubtractionExpression(exp1, exp2);
  }

  public static Expression createMultiplication(Expression exp1, Expression exp2) {
    return new MultiplicationExpression(exp1, exp2);
  }

  public static Expression createDivision(Expression exp1, Expression exp2) {
    return new DivisionExpression(exp1, exp2);
  }

  public static Expression createAnd(Expression exp1, Expression exp2) {
    return new AndExpression(exp1, exp2);
  }

  public static Expression createOr(Expression exp1, Expression exp2) {
    return new OrExpression(exp1, exp2);
  }

  public static Expression createNot(Expression exp) {
    return new NotExpression(exp);
  }

  public static Expression createEquals(Expression exp1, Expression exp2) {
    return new EqualsExpression(exp1, exp2);
  }

  public static Expression createLessThan(Expression exp1, Expression exp2) {
    return new LessThanExpression(exp1, exp2);
  }

  public static Expression createGreaterThan(Expression exp1, Expression exp2) {
    return new GreaterThanExpression(exp1, exp2);
  }
}